<?php

namespace ArtabanMarketplace\Model\Map;

use ArtabanMarketplace\Model\AmpSellerOrderVersion;
use ArtabanMarketplace\Model\AmpSellerOrderVersionQuery;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\InstancePoolTrait;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\DataFetcher\DataFetcherInterface;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\RelationMap;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Map\TableMapTrait;


/**
 * This class defines the structure of the 'amp_seller_order_version' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 */
class AmpSellerOrderVersionTableMap extends TableMap
{
    use InstancePoolTrait;
    use TableMapTrait;
    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'ArtabanMarketplace.Model.Map.AmpSellerOrderVersionTableMap';

    /**
     * The default database name for this class
     */
    const DATABASE_NAME = 'thelia';

    /**
     * The table name for this class
     */
    const TABLE_NAME = 'amp_seller_order_version';

    /**
     * The related Propel class for this table
     */
    const OM_CLASS = '\\ArtabanMarketplace\\Model\\AmpSellerOrderVersion';

    /**
     * A class that can be returned by this tableMap
     */
    const CLASS_DEFAULT = 'ArtabanMarketplace.Model.AmpSellerOrderVersion';

    /**
     * The total number of columns
     */
    const NUM_COLUMNS = 21;

    /**
     * The number of lazy-loaded columns
     */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /**
     * The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS)
     */
    const NUM_HYDRATE_COLUMNS = 21;

    /**
     * the column name for the ID field
     */
    const ID = 'amp_seller_order_version.ID';

    /**
     * the column name for the ORDER_ID field
     */
    const ORDER_ID = 'amp_seller_order_version.ORDER_ID';

    /**
     * the column name for the AMP_SELLER_ID field
     */
    const AMP_SELLER_ID = 'amp_seller_order_version.AMP_SELLER_ID';

    /**
     * the column name for the CUSTOMER_ID field
     */
    const CUSTOMER_ID = 'amp_seller_order_version.CUSTOMER_ID';

    /**
     * the column name for the ORDER_PRODUCT_ID field
     */
    const ORDER_PRODUCT_ID = 'amp_seller_order_version.ORDER_PRODUCT_ID';

    /**
     * the column name for the AMP_SELLER_ORDER_COUNTER field
     */
    const AMP_SELLER_ORDER_COUNTER = 'amp_seller_order_version.AMP_SELLER_ORDER_COUNTER';

    /**
     * the column name for the SELLER_ORDER_REF field
     */
    const SELLER_ORDER_REF = 'amp_seller_order_version.SELLER_ORDER_REF';

    /**
     * the column name for the DISCOUNT field
     */
    const DISCOUNT = 'amp_seller_order_version.DISCOUNT';

    /**
     * the column name for the POSTAGE field
     */
    const POSTAGE = 'amp_seller_order_version.POSTAGE';

    /**
     * the column name for the POSTAGE_TAX field
     */
    const POSTAGE_TAX = 'amp_seller_order_version.POSTAGE_TAX';

    /**
     * the column name for the STATUS_ID field
     */
    const STATUS_ID = 'amp_seller_order_version.STATUS_ID';

    /**
     * the column name for the CREATED_AT field
     */
    const CREATED_AT = 'amp_seller_order_version.CREATED_AT';

    /**
     * the column name for the UPDATED_AT field
     */
    const UPDATED_AT = 'amp_seller_order_version.UPDATED_AT';

    /**
     * the column name for the VERSION field
     */
    const VERSION = 'amp_seller_order_version.VERSION';

    /**
     * the column name for the VERSION_CREATED_AT field
     */
    const VERSION_CREATED_AT = 'amp_seller_order_version.VERSION_CREATED_AT';

    /**
     * the column name for the VERSION_CREATED_BY field
     */
    const VERSION_CREATED_BY = 'amp_seller_order_version.VERSION_CREATED_BY';

    /**
     * the column name for the CUSTOMER_ID_VERSION field
     */
    const CUSTOMER_ID_VERSION = 'amp_seller_order_version.CUSTOMER_ID_VERSION';

    /**
     * the column name for the AMP_SELLER_ID_VERSION field
     */
    const AMP_SELLER_ID_VERSION = 'amp_seller_order_version.AMP_SELLER_ID_VERSION';

    /**
     * the column name for the ORDER_ID_VERSION field
     */
    const ORDER_ID_VERSION = 'amp_seller_order_version.ORDER_ID_VERSION';

    /**
     * the column name for the AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS field
     */
    const AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS = 'amp_seller_order_version.AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS';

    /**
     * the column name for the AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS field
     */
    const AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS = 'amp_seller_order_version.AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS';

    /**
     * The default string format for model objects of the related table
     */
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        self::TYPE_PHPNAME       => array('Id', 'OrderId', 'AmpSellerId', 'CustomerId', 'OrderProductId', 'AmpSellerOrderCounter', 'SellerOrderRef', 'Discount', 'Postage', 'PostageTax', 'StatusId', 'CreatedAt', 'UpdatedAt', 'Version', 'VersionCreatedAt', 'VersionCreatedBy', 'CustomerIdVersion', 'AmpSellerIdVersion', 'OrderIdVersion', 'AmpSellerOrderDeliveryReferenceIds', 'AmpSellerOrderDeliveryReferenceVersions', ),
        self::TYPE_STUDLYPHPNAME => array('id', 'orderId', 'ampSellerId', 'customerId', 'orderProductId', 'ampSellerOrderCounter', 'sellerOrderRef', 'discount', 'postage', 'postageTax', 'statusId', 'createdAt', 'updatedAt', 'version', 'versionCreatedAt', 'versionCreatedBy', 'customerIdVersion', 'ampSellerIdVersion', 'orderIdVersion', 'ampSellerOrderDeliveryReferenceIds', 'ampSellerOrderDeliveryReferenceVersions', ),
        self::TYPE_COLNAME       => array(AmpSellerOrderVersionTableMap::ID, AmpSellerOrderVersionTableMap::ORDER_ID, AmpSellerOrderVersionTableMap::AMP_SELLER_ID, AmpSellerOrderVersionTableMap::CUSTOMER_ID, AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID, AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER, AmpSellerOrderVersionTableMap::SELLER_ORDER_REF, AmpSellerOrderVersionTableMap::DISCOUNT, AmpSellerOrderVersionTableMap::POSTAGE, AmpSellerOrderVersionTableMap::POSTAGE_TAX, AmpSellerOrderVersionTableMap::STATUS_ID, AmpSellerOrderVersionTableMap::CREATED_AT, AmpSellerOrderVersionTableMap::UPDATED_AT, AmpSellerOrderVersionTableMap::VERSION, AmpSellerOrderVersionTableMap::VERSION_CREATED_AT, AmpSellerOrderVersionTableMap::VERSION_CREATED_BY, AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION, AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION, AmpSellerOrderVersionTableMap::ORDER_ID_VERSION, AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS, AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS, ),
        self::TYPE_RAW_COLNAME   => array('ID', 'ORDER_ID', 'AMP_SELLER_ID', 'CUSTOMER_ID', 'ORDER_PRODUCT_ID', 'AMP_SELLER_ORDER_COUNTER', 'SELLER_ORDER_REF', 'DISCOUNT', 'POSTAGE', 'POSTAGE_TAX', 'STATUS_ID', 'CREATED_AT', 'UPDATED_AT', 'VERSION', 'VERSION_CREATED_AT', 'VERSION_CREATED_BY', 'CUSTOMER_ID_VERSION', 'AMP_SELLER_ID_VERSION', 'ORDER_ID_VERSION', 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS', 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS', ),
        self::TYPE_FIELDNAME     => array('id', 'order_id', 'amp_seller_id', 'customer_id', 'order_product_id', 'amp_seller_order_counter', 'seller_order_ref', 'discount', 'postage', 'postage_tax', 'status_id', 'created_at', 'updated_at', 'version', 'version_created_at', 'version_created_by', 'customer_id_version', 'amp_seller_id_version', 'order_id_version', 'amp_seller_order_delivery_reference_ids', 'amp_seller_order_delivery_reference_versions', ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldKeys[self::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        self::TYPE_PHPNAME       => array('Id' => 0, 'OrderId' => 1, 'AmpSellerId' => 2, 'CustomerId' => 3, 'OrderProductId' => 4, 'AmpSellerOrderCounter' => 5, 'SellerOrderRef' => 6, 'Discount' => 7, 'Postage' => 8, 'PostageTax' => 9, 'StatusId' => 10, 'CreatedAt' => 11, 'UpdatedAt' => 12, 'Version' => 13, 'VersionCreatedAt' => 14, 'VersionCreatedBy' => 15, 'CustomerIdVersion' => 16, 'AmpSellerIdVersion' => 17, 'OrderIdVersion' => 18, 'AmpSellerOrderDeliveryReferenceIds' => 19, 'AmpSellerOrderDeliveryReferenceVersions' => 20, ),
        self::TYPE_STUDLYPHPNAME => array('id' => 0, 'orderId' => 1, 'ampSellerId' => 2, 'customerId' => 3, 'orderProductId' => 4, 'ampSellerOrderCounter' => 5, 'sellerOrderRef' => 6, 'discount' => 7, 'postage' => 8, 'postageTax' => 9, 'statusId' => 10, 'createdAt' => 11, 'updatedAt' => 12, 'version' => 13, 'versionCreatedAt' => 14, 'versionCreatedBy' => 15, 'customerIdVersion' => 16, 'ampSellerIdVersion' => 17, 'orderIdVersion' => 18, 'ampSellerOrderDeliveryReferenceIds' => 19, 'ampSellerOrderDeliveryReferenceVersions' => 20, ),
        self::TYPE_COLNAME       => array(AmpSellerOrderVersionTableMap::ID => 0, AmpSellerOrderVersionTableMap::ORDER_ID => 1, AmpSellerOrderVersionTableMap::AMP_SELLER_ID => 2, AmpSellerOrderVersionTableMap::CUSTOMER_ID => 3, AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID => 4, AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER => 5, AmpSellerOrderVersionTableMap::SELLER_ORDER_REF => 6, AmpSellerOrderVersionTableMap::DISCOUNT => 7, AmpSellerOrderVersionTableMap::POSTAGE => 8, AmpSellerOrderVersionTableMap::POSTAGE_TAX => 9, AmpSellerOrderVersionTableMap::STATUS_ID => 10, AmpSellerOrderVersionTableMap::CREATED_AT => 11, AmpSellerOrderVersionTableMap::UPDATED_AT => 12, AmpSellerOrderVersionTableMap::VERSION => 13, AmpSellerOrderVersionTableMap::VERSION_CREATED_AT => 14, AmpSellerOrderVersionTableMap::VERSION_CREATED_BY => 15, AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION => 16, AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION => 17, AmpSellerOrderVersionTableMap::ORDER_ID_VERSION => 18, AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS => 19, AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS => 20, ),
        self::TYPE_RAW_COLNAME   => array('ID' => 0, 'ORDER_ID' => 1, 'AMP_SELLER_ID' => 2, 'CUSTOMER_ID' => 3, 'ORDER_PRODUCT_ID' => 4, 'AMP_SELLER_ORDER_COUNTER' => 5, 'SELLER_ORDER_REF' => 6, 'DISCOUNT' => 7, 'POSTAGE' => 8, 'POSTAGE_TAX' => 9, 'STATUS_ID' => 10, 'CREATED_AT' => 11, 'UPDATED_AT' => 12, 'VERSION' => 13, 'VERSION_CREATED_AT' => 14, 'VERSION_CREATED_BY' => 15, 'CUSTOMER_ID_VERSION' => 16, 'AMP_SELLER_ID_VERSION' => 17, 'ORDER_ID_VERSION' => 18, 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS' => 19, 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS' => 20, ),
        self::TYPE_FIELDNAME     => array('id' => 0, 'order_id' => 1, 'amp_seller_id' => 2, 'customer_id' => 3, 'order_product_id' => 4, 'amp_seller_order_counter' => 5, 'seller_order_ref' => 6, 'discount' => 7, 'postage' => 8, 'postage_tax' => 9, 'status_id' => 10, 'created_at' => 11, 'updated_at' => 12, 'version' => 13, 'version_created_at' => 14, 'version_created_by' => 15, 'customer_id_version' => 16, 'amp_seller_id_version' => 17, 'order_id_version' => 18, 'amp_seller_order_delivery_reference_ids' => 19, 'amp_seller_order_delivery_reference_versions' => 20, ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, )
    );

    /**
     * Initialize the table attributes and columns
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('amp_seller_order_version');
        $this->setPhpName('AmpSellerOrderVersion');
        $this->setClassName('\\ArtabanMarketplace\\Model\\AmpSellerOrderVersion');
        $this->setPackage('ArtabanMarketplace.Model');
        $this->setUseIdGenerator(false);
        // columns
        $this->addForeignPrimaryKey('ID', 'Id', 'INTEGER' , 'amp_seller_order', 'ID', true, null, null);
        $this->addColumn('ORDER_ID', 'OrderId', 'INTEGER', true, null, null);
        $this->addColumn('AMP_SELLER_ID', 'AmpSellerId', 'INTEGER', true, null, null);
        $this->addColumn('CUSTOMER_ID', 'CustomerId', 'INTEGER', true, null, null);
        $this->addColumn('ORDER_PRODUCT_ID', 'OrderProductId', 'VARCHAR', false, 1000, null);
        $this->addColumn('AMP_SELLER_ORDER_COUNTER', 'AmpSellerOrderCounter', 'INTEGER', true, null, null);
        $this->addColumn('SELLER_ORDER_REF', 'SellerOrderRef', 'VARCHAR', false, 100, null);
        $this->addColumn('DISCOUNT', 'Discount', 'DECIMAL', false, 16, 0);
        $this->addColumn('POSTAGE', 'Postage', 'DECIMAL', true, 16, 0);
        $this->addColumn('POSTAGE_TAX', 'PostageTax', 'DECIMAL', true, 16, 0);
        $this->addColumn('STATUS_ID', 'StatusId', 'INTEGER', true, null, null);
        $this->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null, null);
        $this->addPrimaryKey('VERSION', 'Version', 'INTEGER', true, null, 0);
        $this->addColumn('VERSION_CREATED_AT', 'VersionCreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('VERSION_CREATED_BY', 'VersionCreatedBy', 'VARCHAR', false, 100, null);
        $this->addColumn('CUSTOMER_ID_VERSION', 'CustomerIdVersion', 'INTEGER', false, null, 0);
        $this->addColumn('AMP_SELLER_ID_VERSION', 'AmpSellerIdVersion', 'INTEGER', false, null, 0);
        $this->addColumn('ORDER_ID_VERSION', 'OrderIdVersion', 'INTEGER', false, null, 0);
        $this->addColumn('AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS', 'AmpSellerOrderDeliveryReferenceIds', 'ARRAY', false, null, null);
        $this->addColumn('AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS', 'AmpSellerOrderDeliveryReferenceVersions', 'ARRAY', false, null, null);
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('AmpSellerOrder', '\\ArtabanMarketplace\\Model\\AmpSellerOrder', RelationMap::MANY_TO_ONE, array('id' => 'id', ), 'CASCADE', null);
    } // buildRelations()

    /**
     * Adds an object to the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database. In some cases you may need to explicitly add objects
     * to the cache in order to ensure that the same objects are always returned by find*()
     * and findPk*() calls.
     *
     * @param \ArtabanMarketplace\Model\AmpSellerOrderVersion $obj A \ArtabanMarketplace\Model\AmpSellerOrderVersion object.
     * @param string $key             (optional) key to use for instance map (for performance boost if key was already calculated externally).
     */
    public static function addInstanceToPool($obj, $key = null)
    {
        if (Propel::isInstancePoolingEnabled()) {
            if (null === $key) {
                $key = serialize(array((string) $obj->getId(), (string) $obj->getVersion()));
            } // if key === null
            self::$instances[$key] = $obj;
        }
    }

    /**
     * Removes an object from the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database.  In some cases -- especially when you override doDelete
     * methods in your stub classes -- you may need to explicitly remove objects
     * from the cache in order to prevent returning objects that no longer exist.
     *
     * @param mixed $value A \ArtabanMarketplace\Model\AmpSellerOrderVersion object or a primary key value.
     */
    public static function removeInstanceFromPool($value)
    {
        if (Propel::isInstancePoolingEnabled() && null !== $value) {
            if (is_object($value) && $value instanceof \ArtabanMarketplace\Model\AmpSellerOrderVersion) {
                $key = serialize(array((string) $value->getId(), (string) $value->getVersion()));

            } elseif (is_array($value) && count($value) === 2) {
                // assume we've been passed a primary key";
                $key = serialize(array((string) $value[0], (string) $value[1]));
            } elseif ($value instanceof Criteria) {
                self::$instances = [];

                return;
            } else {
                $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or \ArtabanMarketplace\Model\AmpSellerOrderVersion object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value, true)));
                throw $e;
            }

            unset(self::$instances[$key]);
        }
    }

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     */
    public static function getPrimaryKeyHashFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        // If the PK cannot be derived from the row, return NULL.
        if ($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] === null && $row[TableMap::TYPE_NUM == $indexType ? 13 + $offset : static::translateFieldName('Version', TableMap::TYPE_PHPNAME, $indexType)] === null) {
            return null;
        }

        return serialize(array((string) $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)], (string) $row[TableMap::TYPE_NUM == $indexType ? 13 + $offset : static::translateFieldName('Version', TableMap::TYPE_PHPNAME, $indexType)]));
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {

            return $pks;
    }

    /**
     * The class that the tableMap will make instances of.
     *
     * If $withPrefix is true, the returned path
     * uses a dot-path notation which is translated into a path
     * relative to a location on the PHP include_path.
     * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
     *
     * @param boolean $withPrefix Whether or not to return the path with the class name
     * @return string path.to.ClassName
     */
    public static function getOMClass($withPrefix = true)
    {
        return $withPrefix ? AmpSellerOrderVersionTableMap::CLASS_DEFAULT : AmpSellerOrderVersionTableMap::OM_CLASS;
    }

    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param array  $row       row returned by DataFetcher->fetch().
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                 One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @return array (AmpSellerOrderVersion object, last column rank)
     */
    public static function populateObject($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        $key = AmpSellerOrderVersionTableMap::getPrimaryKeyHashFromRow($row, $offset, $indexType);
        if (null !== ($obj = AmpSellerOrderVersionTableMap::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $offset, true); // rehydrate
            $col = $offset + AmpSellerOrderVersionTableMap::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = AmpSellerOrderVersionTableMap::OM_CLASS;
            $obj = new $cls();
            $col = $obj->hydrate($row, $offset, false, $indexType);
            AmpSellerOrderVersionTableMap::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param DataFetcherInterface $dataFetcher
     * @return array
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(DataFetcherInterface $dataFetcher)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = static::getOMClass(false);
        // populate the object(s)
        while ($row = $dataFetcher->fetch()) {
            $key = AmpSellerOrderVersionTableMap::getPrimaryKeyHashFromRow($row, 0, $dataFetcher->getIndexType());
            if (null !== ($obj = AmpSellerOrderVersionTableMap::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                AmpSellerOrderVersionTableMap::addInstanceToPool($obj, $key);
            } // if key exists
        }

        return $results;
    }
    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param Criteria $criteria object containing the columns to add.
     * @param string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::ID);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::ORDER_ID);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::AMP_SELLER_ID);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::CUSTOMER_ID);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::SELLER_ORDER_REF);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::DISCOUNT);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::POSTAGE);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::POSTAGE_TAX);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::STATUS_ID);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::CREATED_AT);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::UPDATED_AT);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::VERSION);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::VERSION_CREATED_AT);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::VERSION_CREATED_BY);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::ORDER_ID_VERSION);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS);
            $criteria->addSelectColumn(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS);
        } else {
            $criteria->addSelectColumn($alias . '.ID');
            $criteria->addSelectColumn($alias . '.ORDER_ID');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ID');
            $criteria->addSelectColumn($alias . '.CUSTOMER_ID');
            $criteria->addSelectColumn($alias . '.ORDER_PRODUCT_ID');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ORDER_COUNTER');
            $criteria->addSelectColumn($alias . '.SELLER_ORDER_REF');
            $criteria->addSelectColumn($alias . '.DISCOUNT');
            $criteria->addSelectColumn($alias . '.POSTAGE');
            $criteria->addSelectColumn($alias . '.POSTAGE_TAX');
            $criteria->addSelectColumn($alias . '.STATUS_ID');
            $criteria->addSelectColumn($alias . '.CREATED_AT');
            $criteria->addSelectColumn($alias . '.UPDATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_BY');
            $criteria->addSelectColumn($alias . '.CUSTOMER_ID_VERSION');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ID_VERSION');
            $criteria->addSelectColumn($alias . '.ORDER_ID_VERSION');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS');
        }
    }

    /**
     * Returns the TableMap related to this object.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getServiceContainer()->getDatabaseMap(AmpSellerOrderVersionTableMap::DATABASE_NAME)->getTable(AmpSellerOrderVersionTableMap::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this tableMap class.
     */
    public static function buildTableMap()
    {
      $dbMap = Propel::getServiceContainer()->getDatabaseMap(AmpSellerOrderVersionTableMap::DATABASE_NAME);
      if (!$dbMap->hasTable(AmpSellerOrderVersionTableMap::TABLE_NAME)) {
        $dbMap->addTableObject(new AmpSellerOrderVersionTableMap());
      }
    }

    /**
     * Performs a DELETE on the database, given a AmpSellerOrderVersion or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or AmpSellerOrderVersion object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderVersionTableMap::DATABASE_NAME);
        }

        if ($values instanceof Criteria) {
            // rename for clarity
            $criteria = $values;
        } elseif ($values instanceof \ArtabanMarketplace\Model\AmpSellerOrderVersion) { // it's a model object
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(AmpSellerOrderVersionTableMap::DATABASE_NAME);
            // primary key is composite; we therefore, expect
            // the primary key passed to be an array of pkey values
            if (count($values) == count($values, COUNT_RECURSIVE)) {
                // array is not multi-dimensional
                $values = array($values);
            }
            foreach ($values as $value) {
                $criterion = $criteria->getNewCriterion(AmpSellerOrderVersionTableMap::ID, $value[0]);
                $criterion->addAnd($criteria->getNewCriterion(AmpSellerOrderVersionTableMap::VERSION, $value[1]));
                $criteria->addOr($criterion);
            }
        }

        $query = AmpSellerOrderVersionQuery::create()->mergeWith($criteria);

        if ($values instanceof Criteria) { AmpSellerOrderVersionTableMap::clearInstancePool();
        } elseif (!is_object($values)) { // it's a primary key, or an array of pks
            foreach ((array) $values as $singleval) { AmpSellerOrderVersionTableMap::removeInstanceFromPool($singleval);
            }
        }

        return $query->delete($con);
    }

    /**
     * Deletes all rows from the amp_seller_order_version table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public static function doDeleteAll(ConnectionInterface $con = null)
    {
        return AmpSellerOrderVersionQuery::create()->doDeleteAll($con);
    }

    /**
     * Performs an INSERT on the database, given a AmpSellerOrderVersion or Criteria object.
     *
     * @param mixed               $criteria Criteria or AmpSellerOrderVersion object containing data that is used to create the INSERT statement.
     * @param ConnectionInterface $con the ConnectionInterface connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doInsert($criteria, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderVersionTableMap::DATABASE_NAME);
        }

        if ($criteria instanceof Criteria) {
            $criteria = clone $criteria; // rename for clarity
        } else {
            $criteria = $criteria->buildCriteria(); // build Criteria from AmpSellerOrderVersion object
        }


        // Set the correct dbName
        $query = AmpSellerOrderVersionQuery::create()->mergeWith($criteria);

        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->beginTransaction();
            $pk = $query->doInsert($con);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $pk;
    }

} // AmpSellerOrderVersionTableMap
// This is the static code needed to register the TableMap for this table with the main Propel class.
//
AmpSellerOrderVersionTableMap::buildTableMap();
